package template;
import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;
public class GetTag extends TagSupport {
   private String name = null;
   private String deflt = null;
   private boolean isDirect = false;
   public void setName(String name) {
      this.name = name;
   }
   public void setDefault(String deflt) {
      this.deflt = deflt;
   }
   public void setDirect(boolean isdirect) {
      this.isDirect = isdirect;
   }
   public int doEndTag() throws JspException {
      String value = 
         (String)pageContext.getAttribute(name, 
                             PageContext.REQUEST_SCOPE);
      if(value == null) {
         value = deflt;
      }
      try {
         if (isDirect == true) {
            // write value as direct output to JspWriter
            pageContext.getOut().print(value);
         }
         else {
            // consider value as resource to be included
            pageContext.include(value);
         }
      }
      catch(IOException ioe) {
         throw new JspTagException("Get Tag: " + ioe);
      }
      catch(ServletException se) {
         throw new JspTagException("Get Tag: " + se);
      }
      return EVAL_PAGE;
   }
}
