package gallery;

import java.util.Iterator;

import javax.servlet.jsp.tagext.BodyTagSupport;

import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.JspTagException;

public class GalleryLayout extends BodyTagSupport {
    public static int GALLERY_DEFAULT = 3;

    private Iterator iterator = null;

    private int width = -1;
    private int borderWidth = 1;
    private int itemsPerRow = GALLERY_DEFAULT;
    private int currCount = 0;
	
    public void setWidth(int width) {
        this.width = width;
    }
	
    public void setBorderWidth(int borderWidth) {
        this.borderWidth = borderWidth;
    }
	
    public void setItemsPerRow(String itemsPerRow) {
        this.itemsPerRow = Integer.parseInt(itemsPerRow);
    }
	
    public void setImages(Iterator iterator) {
        this.iterator = iterator;
    }
	
    public int doStartTag() throws JspTagException {
        log("doStartTag");  
        if ((iterator != null) && iterator.hasNext()) {
            return EVAL_BODY_TAG; 
        }
        else {
            return SKIP_BODY;	
        }
    } 
	
    public int doAfterBody() throws JspTagException { 
        log("doAfterBody");
        if(iterator.hasNext()) { 
            try {
                if (currCount == 0) {
                    bodyContent.write("<TABLE BORDER=" + borderWidth + ">\n<TR>\n");
                }
                bodyContent.write("   <TD>");
                ((GalleryItem)iterator.next()).display(bodyContent);
                bodyContent.write("</TD>");
                currCount++;
				
                if ((currCount % itemsPerRow) == 0) {
                    bodyContent.write("\n</TR>\n<TR>");
                }
                 
                return EVAL_BODY_TAG; 
            }
            catch (java.io.IOException ioe) {
                throw new JspTagException ("IO Error: " + ioe.getMessage());
            }
        }
        else { 
            try {
                bodyContent.write("</TR>\n</TABLE>");
            }
            catch (Exception ex) {}
            return SKIP_BODY; 
        } 
    }
	
    public int doEndTag() throws JspTagException { 
        log("doEndTag");
        try { 
            if (bodyContent != null)
                bodyContent.writeOut(bodyContent.getEnclosingWriter()); 
        }	
        catch(java.io.IOException e) { 
            throw new JspTagException("IO Error: " + e.getMessage()); 
        }
    
        return EVAL_PAGE; 
    } 
	
    private void log(String msg) {
        System.out.println(msg);
    }
}
