package gallery;

import java.io.File;
import java.io.FilenameFilter; 

import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

public class Inventory {
    private String inventoryDirRoot = null;
    private String inventoryURLRoot = null;

    public Inventory(String inventoryDirRoot,
                     String inventoryURLRoot) {
        this.inventoryDirRoot = inventoryDirRoot;
        this.inventoryURLRoot = inventoryURLRoot;
    }
    
    public Iterator getImagesFor(String catalog) {
        File dir = new File(inventoryDirRoot + "/" + catalog);
        String[] fileList = dir.list(new ImageFilter());
        if((fileList != null) && (fileList.length > 0)) {
            List l = new ArrayList();
            for(int i=0; i<fileList.length; i++) {
                l.add(new ImageItem(inventoryURLRoot + catalog + "/" + 
                                    fileList[i], fileList[i]));
            }
            
            return l.iterator();
        }

        return null;
    }

    class ImageFilter implements FilenameFilter {
        public boolean accept(File dir, String name) {
            return(((name.toLowerCase()).endsWith(".jpg")) || 
                   ((name.toLowerCase()).endsWith(".gif")));
        }
    }
}

